src/medux/plugins/timetracker/urls.py
from django.contrib.auth import get_user_model
from django.urls import path, include
from rest_framework import serializers, viewsets

from medux.plugins.timetracker import views
from medux.plugins.timetracker.models import TimeEntry
from medux.common.api.interfaces import IAdministrationURL

User = get_user_model()

app_name = "timetracker"


class TimeEntrySerializer(serializers.HyperlinkedModelSerializer):
    class Meta:
        model = TimeEntry
        fields = "__all__"


class TimeEntryViewSet(viewsets.ModelViewSet):
    queryset = TimeEntry.objects.all()
    serializer_class = TimeEntrySerializer


# Serializers define the API representation.
class UserSerializer(serializers.HyperlinkedModelSerializer):
    class Meta:
        model = User
        fields = ["url", "username", "email", "is_staff"]


# ViewSets define the view behavior.
class UserViewSet(viewsets.ModelViewSet):
    queryset = User.objects.all()
    serializer_class = UserSerializer


# Routers provide an easy way of automatically determining the URL conf.
# router = routers.DefaultRouter()
# router.register(r"users", UserViewSet)
# router.register(r"timeentries", TimeEntryViewSet)


absence_urlpatterns = [
    path(
        "add/<str:absence_type>/",
        views.CreateAbsenceModalView.as_view(),
        name="add",
    ),
    path(
        "request/<int:year>/<int:month>/<int:day>/<str:absence_type>/",
        views.AbsenceRequestView.as_view(),
        name="request",
    ),
    path(
        "<pk>/approve/",
        views.AbsenceApproveView.as_view(),
        name="approve",
    ),
    path(
        "<pk>/decline/",
        views.AbsenceDeclineView.as_view(),
        name="decline",
    ),
    path(
        "<int:pk>/delete/",
        views.AbsenceDeleteView.as_view(),
        name="delete",
    ),
    path(
        "<pk>/cancel/",
        views.AbsenceCancelView.as_view(),
        name="cancel",
    ),
]

absence_type_urlpatterns = [
    path(
        "",
        views.AbsenceTypeListView.as_view(),
        name="list",
    ),
    path(
        "add/",
        views.AbsenceTypeCreateView.as_view(),
        name="add",
    ),
    path(
        "<int:pk>/change/",
        views.AbsenceTypeUpdateView.as_view(),
        name="update",
    ),
    path(
        "<int:pk>/delete/",
        views.AbsenceTypeDeleteView.as_view(),
        name="delete",
    ),
]

holidaypolicy_urlpatterns = [
    path(
        "",
        views.HolidayPolicyListView.as_view(),
        name="list",
    ),
    path(
        "add/",
        views.HolidayPolicyCreateView.as_view(),
        name="add",
    ),
    path(
        "update/<int:pk>/",
        views.HolidayPolicyUpdateView.as_view(),
        name="update",
    ),
    path(
        "delete/<int:pk>/",
        views.HolidayPolicyDeleteView.as_view(),
        name="delete",
    ),
    path(
        "<int:pk>/employees/",
        views.HolidayPolicyEmployeesView.as_view(),
        name="employee-list",
    ),
    path(
        "<int:pk>/employees/add/",
        views.HolidayPolicyEmployeeAddView.as_view(),
        name="employee-add",
    ),
    path(
        "hpa/<int:pk>/delete/",
        views.HolidayPolicyApplicationDeleteView.as_view(),
        name="employee-delete",
    ),
]

timeentry_urlpatterns = [
    path(
        "",
        views.TimeEntryMonthListView.as_view(),
        name="month-list",
    ),
    path("add/", views.TimeEntryCreateView.as_view(), name="add"),
    path("complete/", views.TimeEntryCompleteView.as_view(), name="complete"),
    path(
        "<pk>/change/",
        views.TimeEntryUpdateView.as_view(),
        name="update",
    ),
    path(
        "<pk>/delete/",
        views.TimeEntryDeleteView.as_view(),
        name="delete",
    ),
    path(
        "<int:year>/<int:month>/",
        views.TimeEntryMonthListView.as_view(),
        name="month-list",
    ),
]
urlpatterns = [
    # path("api/", include(router.urls)),
    path(
        "holidaypolicy/",
        include(
            (holidaypolicy_urlpatterns, "holidaypolicy"), namespace="holidaypolicy"
        ),
    ),
    path("absence/", include((absence_urlpatterns, "absence"), namespace="absence")),
    path(
        "absencetype/",
        include((absence_type_urlpatterns, "absencetype"), namespace="absencetype"),
    ),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("overview/", views.OverView.as_view(), name="overview"),
    path(
        "overview/<int:year>/<int:month>/",
        views.OverView.as_view(),
        name="overview-month",
    ),
    path("holidays/", views.HolidaysView.as_view(), name="current-holidays"),
    path("holidays/<int:year>/", views.HolidaysView.as_view(), name="holidays"),
    path(
        "pending-holidays/",
        views.PendingAbsenceRequestsView.as_view(),
        name="pending-absence-requests",
    ),
    path(
        "timeentry/",
        include((timeentry_urlpatterns, "timeentry"), namespace="timeentry"),
    ),
    path(
        "monthlytimebilling/",
        views.MonthlyTimeBillingListView.as_view(),
        name="monthlytimebilling-list",
    ),
    path(
        "monthlytimebilling/<int:year>/<int:month>/",
        views.MonthlyTimeBillingCreateView.as_view(),
        name="monthlytimebilling",
    ),
    path(
        "timebalanceentry/",
        views.TimeBalanceEntryListView.as_view(),
        name="time-balance-entry-list",
    ),
    # path(
    #     "api/check_payout_time_credit_hours",
    #     views.check_payout_time_credit_hours,
    #     name="check-check_payout_time_credit_hours",
    # ),
    path("archive", views.ArchiveView.as_view(), name="archive"),
    # WorkingTimeRange
    path(
        "work_schedule/",
        views.CurrentWorkScheduleView.as_view(),
        name="current-work-schedule",
    ),
    # TODO: should have no effect, place somewhere else?
    path(
        "absence/", views.AbsenceListWidgetView.as_view(), name="current-absence-days"
    ),
    # generic
    path("logout/", views.LogoutWithTimeTrackingView.as_view(), name="logout"),
]

admin_urlpatterns = []


class TimetrackerAdminURLs(IAdministrationURL):
    namespace = "timetracker"
    urlpatterns = [
        path(
            "pending-absence-requests/",
            views.admin.PendingAbsenceRequestsView.as_view(),
            name="pending-absence-requests",
        )
    ]

src/medux/plugins/timetracker/templates/timetracker/absence_list_card.html
{% load i18n medux %}
<div class="card">
  <div class="card-header">
    <div>
      <h3 class="card-title">{% translate 'Absences' %}</h3>
      <p class="card-subtitle">{{ from_date|date:"SHORT_DATE_FORMAT" }} - {{ to_date|date:"SHORT_DATE_FORMAT" }}</p>
    </div>
  </div>
  <div class="table-responsive">
    <table class="table align-middle">
      <thead>
      <tr>
        <th>{% translate 'Type' %}</th>
        <th>{% translate 'max/year' %}</th>
        <th>{% translate 'Consumed' %}</th>
        <th>{% translate 'Remaining' %}</th>
        <th></th>
      </tr>
      </thead>
      <tbody>
      {% for absence_type in absence_types %}
        <tr>
          <td>
            {{ absence_type.type }}
            {% if absence_type.contingent %}
              <div class="progress">
                <div class="progress-bar" style="width: {{ absences.training.percent }}%" role="progressbar" aria-valuenow="{{ absence_type.balance }}" aria-valuemin="0" aria-valuemax="{{ absence_type.contingent }}">
                  <span class="visually-hidden">{{ absence_type.balance }}</span>
                </div>
              </div>
            {% endif %}
          </td>

          <td><span class="btn btn-action cursor-default" title="{% translate 'Holiday contingent since:'%} {{ absence_type.contingent_since }}">{{ absence_type.contingent }}</span></td>

          <td>{{ absence_type.consumed }}</td>

          <td>{{ absence_type.balance|prefix_plus }}</td>

          <td class="text-end">
            {% with label=absence_type.type.label %}
              <button
                  class="btn btn-action"
                  hx-get="{% url 'timetracker:absence:add' absence_type=absence_type.type.uuid %}"
                  hx-target="#dialog"
                  title="{% blocktranslate %}Request {{ label }}{% endblocktranslate %}"
              ><i class="bi bi-plus-lg"></i></button></td>
            {% endwith %}
        </tr>
      {% endfor %}

    </table>
  </div>
</div>

src/medux/plugins/timetracker/templates/timetracker/adm_holidaypolicy_confirm_delete.html
{% extends 'common/modal-form.html' %}
{% load i18n %}

{% block body %}
  <p>
  {% translate 'Do you really want to delete this holiday policy?' %}
  </p>
  <p>
  {% blocktranslate trimmed count amount=applications|length %}
      There is {{ amount }} user that is affected by this policy:
  {% plural %}
     There are {{ amount }} users that are affected by this policy:
  {% endblocktranslate %}
  </p>
  <div class="list-group overflow-auto">
  {% for application in applications %}
    <div class="list-group-item">
      <div class="list-group-item-text text-muted">
          {{ application.employee }}
      </div>
    </div>
  {% endfor %}

  </div>
{% endblock %}

{% block submit-button %}
  <button hx-post="{{ request.path }}" class="btn btn-danger" type="submit" title="{% translate 'Delete' %}">
    <i class="bi bi-trash"></i>
    {% translate 'Delete' %}
  </button>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/adm_holidaypolicy_employees.html
{% extends 'common/modal-form.html' %}
{% load i18n crispy_forms_tags %}

{% block title %}
  {% with absence_type=holiday_policy.absence_type %}

  {% blocktranslate %}Manage employees using policy '{{ absence_type }}/{{ holiday_policy }}'{% endblocktranslate %}
  {% endwith %}
{% endblock %}

{% block modal-body %}
  <div class="table-responsive">
    <table class="table">
      <thead>
      <tr>
        <th>{% translate 'Employee' %}</th>
        <th>{% translate 'Applicable at' %}</th>
        <th></th>
      </tr>
      </thead>
      <tbody
          id="holiday-policy-applications"
          hx-get="{{ request.path }}"
          hx-trigger="timetracker:holidaypolicy:changed from:body"
          hx-target="#holiday-policy-applications"
          hx-select="#holiday-policy-applications"
          hx-swap="outerHTML"
      >
      {% for application in applications %}
          <tr>
              <td>{{ application.employee }}</td>
              <td>{{ application.application_date }}</td>
              <td class="text-end">
                  <button
                          class="btn btn-action"
                          hx-post="{% url 'timetracker:holidaypolicy:employee-delete' pk=application.pk %}"
                  ><i class="bi bi-trash"></i></button>
              </td>
          </tr>
      {% empty %}
          <tr>
              <td colspan="3">{% translate 'No employees are using this policy.' %}</td>
          </tr>
      {% endfor %}
      </tbody>
    </table>
  </div>
    <div class="modal-body">
        <div
                hx-get="{% url 'timetracker:holidaypolicy:employee-add' pk=holiday_policy.pk %}"
                hx-trigger="load, timetracker:holidaypolicy:deleted from:body"
                hx-target="this"
        ></div>
    </div>
{% endblock %}

{% block footer %}
    <button class="btn" data-bs-dismiss="modal" title="{% translate 'Close' %}">
        <i class="bi bi-check-lg"></i>
        {% translate 'Close' %}
    </button>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/admin.html
{% extends 'timetracker/base.html' %}
{% load i18n %}

{% block content %}
  <div class="row"></div>
  <div class="card">
    <div class="card-header">
      <h3>{% translate 'Pending absence requests' %}</h3>
    </div>
    <div id="pending-absence-requests"
         hx-get="{% url 'timetracker:pending-absence-requests' %}"
         hx-trigger="load"
    ></div>
  </div>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/base.html
{% extends 'core/base.html' %}
{% load static i18n %}

{% block sidebar-menu %}
    {% include 'common/widgets/vertical_menu.html' with menu=menus.timetracker %}
{% endblock %}

{% block styles %}
    <link rel="stylesheet" href="{% static 'timetracker/css/timetracker.css' %}">
    {# Dynamic colors for absences #}
    {% if absence_types %}
        <style>
{#            {% for a in absence_types %}#}
                {#.absence-type-{{a.uuid}}.new {#}
                {#    background-image: linear-gradient(0deg,#}
                {#            rgba(255, 255, 255, 0.15) 25%,#}
                {#            transparent 25%,#}
                {#            transparent 50%,#}
                {#            rgba(255, 255, 255, 0.15) 50%,#}
                {#            rgba(255, 255, 255, 0.15) 75%,#}
                {#            transparent 75%,#}
                {#            transparent);#}
                {#    background-size: 8px 8px;#}
                {#}#}
{#            {% endfor %}#}
            .day.editable:hover {
                background-color: rgba(var(--medux-{{ user.color }}-rgb),.12) !important;
            }
        </style>
    {% endif %}
{% endblock %}


{#{% block scripts %}#}
{#  <script src="{% static 'timetracker/js/timetracker.js' %}"></script>#}
{#{% endblock %}#}

src/medux/plugins/timetracker/templates/timetracker/dummy_translations_to_keep.html
{% load i18n %}
{# See https://stackoverflow.com/a/8177100/818131 #}

{% translate 'Holiday' %}
{% translate 'Special' %}
{% translate 'Training' %}
{% translate 'CTO' %}

src/medux/plugins/timetracker/templates/timetracker/holidaypolicyapplication_form.html
{% load crispy_forms_tags %}
<h4>Apply this policy to an employee at a specific date:</h4>
{% crispy add_form %}

src/medux/plugins/timetracker/templates/timetracker/holidays.html
{% extends 'timetracker/base.html' %}
{% load i18n %}
{% block page-title %}{% translate 'Holidays' %}{% endblock %}

{% block content %}
    {#  {% get_current_language as language %}#}
    {#  <!-- Current language: {{ language }} -->#}
    <div id="content" class="card">
        <div class="card-header">
            <h3 class="card-title">{{ year }}</h3>
            <div class="card-actions">
                <button type="button"
                        class="btn btn-action"
                        hx-get="{% url 'timetracker:holidays' year=prev_year %}"
                        hx-target="#content"
                        hx-select="#content"
                        hx-push-url="true"
                        hx-swap="outerHTML"
                        title="{{ prev_year }}"
                >
                    <i class="bi bi-arrow-left"></i></button>
                {#        <span class="btn-group-text text-nowrap p-2 w-25 text-center">{{ year }}</span>#}
                <button class="btn btn-action"
                        type="button"
                        hx-get="{% url 'timetracker:current-holidays' %}"
                        hx-target="#content"
                        hx-select="#content"
                        hx-push-url="true"
                        hx-swap="outerHTML"
                        title="{% translate 'Current year' %}: {{ year }}"
                ><i class="bi bi-calendar"></i></button>
                <button type="button"
                        class="btn btn-action"
                        hx-get="{% url 'timetracker:holidays' year=next_year %}"
                        hx-target="#content"
                        hx-select="#content"
                        hx-push-url="true"
                        hx-swap="outerHTML"
                        title="{{ next_year }}"
                ><i class="bi bi-arrow-right"></i></button>
            </div>
        </div>
        <div class="card-body">
            {{ calendar }}
        </div>
        <div class="card-footer">
            <ul class="list-inline">
                <li class="list-inline-item me-4 align-middle">
                    <div class="d-inline-block day new day public p-2"
                    title="{% translate 'Public holiday' %}: {{ country_code }}">
                    </div>
                    {% translate 'Public holiday' %}
                </li>
                {% for absence_type in absence_types %}
                    <li class="list-inline-item me-4 align-middle">
                        <div class="d-inline-block day new p-2 absence bg-{{ absence_type.color }} text-{{ absence_type.color }}-fg absence-type-{{ absence_type.uuid }}"
                             title="{% translate 'Requested' %}"></div>
                        <div class="d-inline-block day approved p-2 absence bg-{{ absence_type.color }} text-{{ absence_type.color }}-fg absence-type-{{ absence_type.uuid }}"
                             title="{% translate 'Approved' %}"></div>
                        {% translate absence_type.label %}
                    </li>
                {% endfor %}


{#        <li class="list-inline-item me-4">#}
{#            <span class="badge badge-pill p-0 bg-warning"><i class="bi bi-x"></i></span>#}
{#            {% translate 'Declined' %}#}
{#        </li>#}
{#        <li class="list-inline-item me-4">#}
{#            <span class="badge badge-pill p-0 bg-secondary"><i class="bi bi-check"></i></span>#}
{#            {% translate 'Consumed' %}#}
{#        </li>#}
        </ul>
    </div>
    </div>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/logout_with_timetracking_form.html
{% extends 'common/modal-form.html' %}
{% load i18n %}

{% block submit-button %}
  <button hx-post="{{ request.path }}" class="btn btn-primary" type="submit" title="{% translate 'Save time entry and log out' %}">
    <i class="bi bi-box-arrow-right me-2"></i>
    {% translate 'Save time entry and log out' %}
  </button>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/month_submission_form.html
{% extends 'common/modal-form.html' %}
{% load i18n medux crispy_forms_tags %}

{% block title %}{% blocktranslate %}Submit {{ month_name }} {{ year }}{% endblocktranslate %}{% endblock %}

{% block body %}
  <p>
    {% blocktranslate %}Please confirm that you want to submit the following data for {{ month_name }} {{ year }}:{% endblocktranslate %}
  </p>
  <div class="alert alert-warning">
    {% blocktranslate %}After submitting, times for this month cannot be changed anymore.{% endblocktranslate %}
  </div>
  <table class="table">
    <tr>
      <th>{% translate 'Target hours' %}</th>
      <td>{{ object.time_targeted|as_hours }}</td>
    </tr>
    <tr>
      <th>{% translate 'Worked hours' %}</th>
      <td>{{ object.time_worked|as_hours }}</td>
    </tr>
    {% if time_delta %}
      <tr>
        <th>
          {% if time_delta > 0 %}
            {% translate 'Time credit' %}
          {% elif time_delta < 0 %}
            {% translate 'Missing hours' %}
          {% endif %}
        </th>
        <td>
           {{ time_delta|prefix_plus }}
        </td>
      </tr>
    {% endif %}
      <tr>
        <th>{% translate 'Time account (current balance)' %}</th>
        <td>
          {{ time_account_balance|prefix_plus|default:0 }}
        </td>
      </tr>
  </table>

  {% crispy form %}

{% endblock %}


{% block submit-button %}
  <button hx-post="{{ request.path }}" class="btn btn-primary" type="submit" title="{% translate 'Submit' %}">
    <i class="bi bi-check-lg"></i>
    {% translate 'Submit' %}
  </button>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/monthlytimebilling_list_card.html
{% load i18n django_tables2 %}
<div class="card table-responsive mb-3" id="time-entries-month">
  <div class="card-header">
    <h3 class="card-title">{% translate 'Monthly time billings' %}</h3>
  </div>
  {% render_table table %}
</div>

src/medux/plugins/timetracker/templates/timetracker/overview.html
{% extends 'timetracker/base.html' %}
{% load i18n medux %}

{% block content %}
  {% if user.is_employee %}
    <div id="timetracker-overview" class="container">
      <div class="row d-flex align-items-stretch">
        <div class="col-12 col-md-5 col-lg-4 mb-3" >
          <div
              class="card h-100"
              hx-get="{% url 'timetracker:current-work-schedule' %}"
              hx-trigger="load"
          >
            <div class="card-body">{% translate 'Loading current work schedule...' %}</div>
          </div>
        </div>

        <div class="col-12 col-md-5 col-lg-5 mb-3">
          <div
              class="card h-100"
              hx-get="{% url 'timetracker:current-absence-days' %}"
              hx-trigger="load, timetracker:absence:changed from:body"
              hx-disinherit="*"
          >
              <div class="card-body">{% translate 'Loading absences...' %}</div>
          </div>
        </div>

        <div class="col-12 col-md-2 col-lg-3 mb-3">
          <div class="card h-100">
            <div class="card-header">
              <h3 class="card-title">
                {% translate 'Time account'%}
              </h3>
            </div>
            <div class="card-body d-flex align-items-center justify-content-center">
              <div class="fs-2">
                {{ time_account_balance|as_hours|floatformat:2|prefix_plus }}
                <span class="d-inline d-md-none d-lg-inline">{% translate 'hours' %}</span>
              </div>
            </div>
          </div>
        </div>

        <div class="col-12">
          <div
              class="card"
              hx-get="{% url 'employees:workingcontract-current' user.employee.pk %}"
              hx-trigger="load">
            <div class="card-body">{% translate 'Loading working contract...' %}</div>
          </div>
        </div>
      </div>
    </div>
  {% endif %}
{% endblock %}

{% block scripts %}
  <script>
    /***
     * Swaps in the body of error pages returned from htmx requests
     * TODO: make this more generically
     */
    htmx.on("htmx:beforeOnLoad", function (event) {
      const xhr = event.detail.xhr
      if (xhr.status === 500 || xhr.status === 403 || xhr.status === 404) {
        event.stopPropagation() // Tell htmx not to process these requests
        event.target.getElementsByClassName("card-body")[0].innerHTML += xhr.response // Swap in body of response instead
      }
    })
  </script>
{% endblock %}

src/medux/plugins/timetracker/templates/timetracker/timebalanceentry_list_card.html
{% load i18n medux %}
<div class="card table-responsive mb-3" id="time-balances">
    <div class="card-header">
        <h3 class="card-title">{% translate 'Time credit balances' %}</h3>
    </div>

    <div class="table-responsive">
        <table class="table">
            <thead>
            <tr>
                <th>{% translate 'Date' %}</th>
                <th>{% translate 'Accounting month' %}</th>
                <th>{% translate 'Entry' context "time entry, posting" %}</th>
                <th>{% translate 'Comment' %}</th>
                <th>{% translate 'Balance' %}</th>
            </tr>
            </thead>
            <tbody>
            {% for object in object_list %}
                <tr>
                    <td>{{ object.created|date }}</td>
                    <td>{% if object.time_billing %}
                      <a href="{% url 'timetracker:timeentry:month-list' object.time_billing.month.year object.time_billing.month.month %}">
                        {{ object.time_billing.month.month|month_name }} {{ object.time_billing.month.year }}
                      </a>
                    {% else %}
                      -
                    {% endif %}
                    </td>
                    <td>{{ object.time_delta|as_hours|floatformat:2|prefix_plus }} h</td>
                    <td>{{ object.comment|default:"" }}</td>
                    <td>{{ object.balance|as_hours|floatformat:2|prefix_plus }} h</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
</div>

src/medux/plugins/timetracker/templates/timetracker/timeentry_confirm_delete.html
{% extends 'common/modal-form.html' %}
{% load i18n %}

{% block title %}{% translate 'Delete time entry' %}{% endblock %}

{% block body %}
  <div class="card-text">
      {% translate 'Are you sure you want to delete this item? This action cannot be undone.' %}
  </div>
{% endblock %}

{% block submit-button %}
  <button hx-post="{{ request.path }}" class="btn btn-danger" type="submit" title="{% translate 'Delete' %}">
    <i class="bi bi-trash-lg"></i>
    {% translate 'Delete' %}
  </button>
{% endblock %}